unit principal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    BitBtn1: TBitBtn;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    RadioGroup1: TRadioGroup;
    Label11: TLabel;
    Label12: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Edit3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

// **Extrutura "TAcionador"  
type
  TAcionador = record
   Tipo: integer;
   Serial3d: integer;
   Serial7d: integer;
   Contador: integer;
   Bateria: integer;
   Botao: integer;
  end;

var
  Form1: TForm1;

  function formataSerial(s3d: integer; s7d: integer; formato: integer): string;

implementation

{$R *.dfm}

// **Importao da DLL "LeitoraUSB.dll"
function LerAcionador(tipo_serial: integer): TAcionador; stdcall; external 'LeitoraUSB.dll';

// **Funo auxiliar para formatao do serial
function formataSerial(s3d: integer; s7d: integer; formato: integer): string;
var
        ret: string;
begin
        ret:= '';

        case ( formato ) of
         0,1:
         begin  // 7 dgitos
          ret:= IntToHex(s7d,7);
         end;

         2:
         begin  // 10 dgitos
          ret:= IntToHex(s3d,3) + IntToHex(s7d,7);
         end;
        end;

        Result:= ret;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
        retorno: TAcionador;
        formato: integer;
begin
        formato:= RadioGroup1.ItemIndex;

        retorno:= LerAcionador( formato );

        if (retorno.Tipo <> 0) then
        begin
         Label6.Caption:= '- - - -';
         Edit1.Clear;
         Edit2.Clear;
         Label7.Caption:= '- - - -';
         Label12.Caption:= '- - - -';
        end;

        case retorno.Tipo of
         -2: Label6.Caption:= 'Erro!';
         -1: Label6.Caption:= 'No conectada!';

          1: begin
              Label6.Caption:= 'Controle remoto (TX)';
              Edit1.Text:= formataSerial(retorno.Serial3d, retorno.Serial7d, formato);
              Edit2.Text:= IntToHex(retorno.Contador,4);

              if (retorno.Bateria = 0) then
               Label7.Caption:= 'BOA'
              else
               Label7.Caption:= 'FRACA';

              if (retorno.Botao = 0) then
               Label12.Caption:= '- - - -'
              else
               Label12.Caption:= IntToStr(retorno.Botao);
             end;

          2: begin
              Label6.Caption:= 'TAG Ativo (TA)';
              Edit1.Text:= formataSerial(retorno.Serial3d, retorno.Serial7d, formato);

              if (retorno.Bateria = 0) then
               Label7.Caption:= 'BOA'
              else
               Label7.Caption:= 'FRACA';
             end;

          3: begin
              Label6.Caption:= 'Carto de proximidade (CT)';
              Edit1.Text:= formataSerial(retorno.Serial3d, retorno.Serial7d, formato);
             end;

          8: begin
              Label6.Caption:= 'Entrada Wiegand';
              Edit1.Text:= formataSerial(retorno.Serial3d, retorno.Serial7d, formato);
             end;

          9: begin
              Label6.Caption:= 'Entrada RS-485';
              Edit1.Text:= formataSerial(retorno.Serial3d, retorno.Serial7d, formato);
             end;
        end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
        if (BitBtn1.Caption = 'Habilita') then
        begin
         Timer1.Enabled:= true;
         BitBtn1.Font.Color:= clGreen;
         BitBtn1.Caption:= 'Desabilita';
        end
        else
        begin
         Timer1.Enabled:= false;
         BitBtn1.Font.Color:= clWindowText;
         BitBtn1.Caption:= 'Habilita';
        end;
end;

procedure TForm1.Edit3Click(Sender: TObject);
begin
        Edit3.SelectAll;
end;

end.
